#ifndef __DEBUG_H__
#define __DEBUG_H__

#include <stdio.h>
#include <assert.h>
#include <errno.h>

#ifdef WIN32
#ifdef DEBUG
#	define trace(fmt, ...) \
	fprintf(stderr, "%s:%d: " fmt "\n", __FUNCTION__, __LINE__, __VA_ARGS__)
#else
#	define trace(fmt, ...)
#endif
#define error(fmt, ...) \
	fprintf(stderr, "E:%s:%d: " fmt "\n", __FUNCTION__, __LINE__, __VA_ARGS__)

#else
#ifdef DEBUG
#	define trace(fmt, args...) \
		fprintf(stderr, "%s:%d: " fmt "\n", __FUNCTION__, __LINE__, ##args)
#	define debugonly( arg )  arg
#else
#	define trace( fmt, args...)
#	define debugonly( arg )
#endif

#define error( fmt, args...) \
	fprintf(stderr, "E:%s:%d: " fmt "\n", __FUNCTION__, __LINE__, ##args)

#endif

#endif  // __DEBUG_H__

