#ifndef __NAND_H__
#define __NAND_H__

#include "types.h"

enum config {
	SECT_PER_PAGE = 8,
	PAGE_PER_BLK = 128,
	TOTALSIZE_GB = 32,
	EXTRABLKS = 1967
};

struct config_nand {
	_u16 sect_per_page;
	_u16 page_per_blk;
	_u32 numblks;

	_u32 totalsize;
	_u32 extrablks;

	_u8 bit_sect_per_page;
	_u8 bit_page_per_blk;
};

extern struct config_nand config_nand;

#define LPA_MASK_SECT (-config_nand.sect_per_page)
#define LPA_F_SECT(sect) (((sect) & LPA_MASK_SECT) >> (config_nand.bit_sect_per_page))
#define LSN_F_LPA(lpa)      ((lpa)*config_nand.sect_per_page)

// enum for optStat
enum { NAND_REQ_DATA=0,
		NAND_REQ_GC,
		NAND_REQ_WARM,
};

int nand_open();
void nand_close();

_t_sect nand_page_read(unsigned int blk_no, unsigned int page_no, 
	unsigned int lsn, int optStat);
void nand_page_write(unsigned int blk_no, unsigned int page_no,
	unsigned int lsn, int optStat);
void nand_block_erase(unsigned int blk_no, int optStat);

#endif // __NAND_H__
